- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | List of all members
StarObject Class Reference

an object corresponding to an OLE directory More...

`#include <StarObject.hxx>`

Inheritance diagram for StarObject:

## Public Member Functions
| StarObject (char const *passwd, shared_ptr< STOFFOLEParser::OleDirectory > directory)
| constructor More...
virtual | ~StarObject ()
| destructor More...
bool | parse ()
| try to parse data More...
STOFFDocument::Kind | getDocumentKind () const
| returns the document kind More...
char const * | getPassword () const
| returns the document password (the password given by the user) More...
shared_ptr< STOFFOLEParser::OleDirectory > | getOLEDirectory ()
| returns the object directory More...
shared_ptr< StarAttributeManager > | getAttributeManager ()
| returns the attribute manager More...
shared_ptr< StarFormatManager > | getFormatManager ()
| returns the format manager More...
librevenge::RVNGPropertyList const & | getMetaData () const
| returns the meta data (filled by readSfxDocumentInformation) More...
void | cleanPools ()
| clean each pool More...
shared_ptr< StarItemPool > | getNewItemPool (StarItemPool::Type type)
| returns a new item pool for this document More...
shared_ptr< StarItemPool > | findItemPool (StarItemPool::Type type, bool isInside)
| check if a pool corresponding to a given type is opened if so returned it. More...
shared_ptr< StarItemPool > | getCurrentPool (bool onlyInside=true)
| returns the current all/inside pool More...
bool | readPersistData (StarZone &zone, long endPos)
| try to read persist data More...
bool | readSfxStyleSheets (STOFFInputStreamPtr input, std::string const &name)
| try to read a spreadshet style zone: SfxStyleSheets More...
bool | readItemSet (StarZone &zone, std::vector< STOFFVec2i > const &limits, long endPos, StarItemSet &itemSet, StarItemPool *pool=0, bool isDirect=false)
| try to read a list of item More...

## Protected Member Functions
bool | readPersistElements (STOFFInputStreamPtr input, std::string const &name)
| the "persist elements" small ole: the list of object More...
bool | readSfxDocumentInformation (STOFFInputStreamPtr input, std::string const &name)
| try to read the document information : "SfxDocumentInformation" More...
bool | readSfxPreview (STOFFInputStreamPtr input, std::string const &name)
| try to read the preview : "SfxPreview" More...
bool | readSfxWindows (STOFFInputStreamPtr input, libstoff::DebugFile &ascii)
| try to read the windows information : "SfxWindows" More...
bool | readStarFrameworkConfigFile (STOFFInputStreamPtr input, libstoff::DebugFile &ascii)
| try to read the "Star Framework Config File" More...
| StarObject (StarObject const &orig, bool duplicateState)
| copy constructor More...

## Protected Attributes
char const * | m_password
| the document password More...
shared_ptr< STOFFOLEParser::OleDirectory > | m_directory
| the directory More...
shared_ptr< StarObjectInternal::State > | m_state
| the state More...
librevenge::RVNGPropertyList | m_metaData
| the meta data More...

## Private Member Functions
| StarObject (StarObject const &orig)
StarObject & | operator= (StarObject const &orig)

## Detailed Description

an object corresponding to an OLE directory

## Constructor & Destructor Documentation

StarObject::StarObject | ( | char const * | passwd,
|  | shared_ptr< STOFFOLEParser::OleDirectory > | directory
| ) |  |

constructor

StarObject::~StarObject | ( |  | ) |
| virtual

destructor

StarObject::StarObject | ( | StarObject const & | orig,
|  | bool | duplicateState
| ) |  |
| protected

copy constructor

StarObject::StarObject | ( | StarObject const & | orig | ) |
| private

## Member Function Documentation

void StarObject::cleanPools | ( |  | ) |

clean each pool

Referenced by StarObjectChart::~StarObjectChart(), StarObjectDraw::~StarObjectDraw(), StarObjectSpreadsheet::~StarObjectSpreadsheet(), and StarObjectText::~StarObjectText().

shared_ptr< StarItemPool > StarObject::findItemPool | ( | StarItemPool::Type | type,
|  | bool | isInside
| ) |  |

check if a pool corresponding to a given type is opened if so returned it.

Note
  if isInside is set only look for inside pool

Referenced by StarObjectSmallText::read(), StarObjectSpreadsheet::readSCColumn(), StarObjectSmallGraphic::readSVDRObjectAttrib(), StarObjectSmallGraphic::readSVDRObjectCaption(), StarObjectSmallGraphic::readSVDRObjectCircle(), StarObjectSmallGraphic::readSVDRObjectEdge(), StarObjectSmallGraphic::readSVDRObjectGraph(), StarObjectSmallGraphic::readSVDRObjectMeasure(), StarObjectSpreadsheet::sendCell(), and StarObjectSpreadsheet::updatePageSpans().

shared_ptr< StarAttributeManager > StarObject::getAttributeManager | ( |  | ) |

returns the attribute manager

Referenced by StarItemPoolInternal::State::getDefaultAttribute(), StarItemPool::readAttribute(), and StarObjectText::readSWAttribute().

shared_ptr< StarItemPool > StarObject::getCurrentPool | ( | bool | onlyInside = `true` | ) |

returns the current all/inside pool

Referenced by StarObjectChart::readSCHAttributes().

STOFFDocument::Kind StarObject::getDocumentKind | ( |  | ) | const

returns the document kind

Referenced by StarObjectText::readDrawingLayer(), StarObjectChart::readSfxStyleSheets(), StarObjectDraw::readSfxStyleSheets(), StarObjectText::readSfxStyleSheets(), StarObjectSpreadsheet::readSfxStyleSheets(), and readSfxStyleSheets().

shared_ptr< StarFormatManager > StarObject::getFormatManager | ( |  | ) |

returns the format manager

Referenced by StarObjectSpreadsheet::readCalcDocument(), StarObjectChart::readSCHAttributes(), StarObjectText::readSWContent(), StarObjectText::readSWNumRule(), StarObjectText::readSwPageStyleSheets(), StarObjectText::readSWTable(), StarObjectText::readSWTableBox(), StarObjectText::readSWTableLine(), StarObjectText::readSWTextZone(), StarObjectText::readSWTOXList(), StarObjectText::readWriterDocument(), and StarObjectSpreadsheet::sendCell().

librevenge::RVNGPropertyList const& StarObject::getMetaData | ( |  | ) | const
| inline

returns the meta data (filled by readSfxDocumentInformation)

shared_ptr< StarItemPool > StarObject::getNewItemPool | ( | StarItemPool::Type | type | ) |

returns a new item pool for this document

Referenced by parse(), StarObjectSmallText::read(), StarObjectSpreadsheet::readCalcDocument(), StarObjectChart::readChartDocument(), StarObjectText::readDrawingLayer(), StarObjectSpreadsheet::readSCColumn(), StarObjectChart::readSCHAttributes(), StarObjectModel::readSdrPage(), StarObjectChart::readSfxStyleSheets(), StarObjectDraw::readSfxStyleSheets(), StarObjectText::readSfxStyleSheets(), StarObjectSpreadsheet::readSfxStyleSheets(), readSfxStyleSheets(), StarObjectSmallGraphic::readSVDRObjectAttrib(), StarObjectSmallGraphic::readSVDRObjectCaption(), StarObjectSmallGraphic::readSVDRObjectCircle(), StarObjectSmallGraphic::readSVDRObjectEdge(), StarObjectSmallGraphic::readSVDRObjectGraph(), and StarObjectSmallGraphic::readSVDRObjectMeasure().

shared_ptr<STOFFOLEParser::OleDirectory> StarObject::getOLEDirectory | ( |  | ) |
| inline

returns the object directory

Referenced by StarObjectChart::parse(), StarObjectText::parse(), StarObjectDraw::parse(), and StarObjectSpreadsheet::parse().

char const* StarObject::getPassword | ( |  | ) | const
| inline

returns the document password (the password given by the user)

Referenced by StarObjectSpreadsheet::readCalcDocument(), StarObjectChart::readChartDocument(), StarObjectDraw::readDrawDocument(), StarObjectText::readDrawingLayer(), StarFileManager::readEmbeddedPicture(), StarObjectChart::readSfxStyleSheets(), StarObjectDraw::readSfxStyleSheets(), StarObjectText::readSfxStyleSheets(), StarObjectSpreadsheet::readSfxStyleSheets(), readSfxStyleSheets(), StarObjectText::readSwNumRuleList(), StarObjectText::readSwPageStyleSheets(), and StarObjectText::readWriterDocument().

StarObject& StarObject::operator= | ( | StarObject const & | orig | ) |
| private

bool StarObject::parse | ( |  | ) |

try to parse data

Referenced by StarObjectChart::parse(), StarObjectText::parse(), StarObjectDraw::parse(), and StarObjectSpreadsheet::parse().

bool StarObject::readItemSet | ( | StarZone & | zone,
|  | std::vector< STOFFVec2i > const & | limits,
|  | long | endPos,
|  | StarItemSet & | itemSet,
|  | StarItemPool * | pool = `0`,
|  | bool | isDirect = `false`
| ) |  |

try to read a list of item

Referenced by StarObjectSmallText::read(), StarObjectChart::readSCHAttributes(), and StarItemPool::readStyles().

bool StarObject::readPersistData | ( | StarZone & | zone,
|  | long | endPos
| ) |  |

try to read persist data

Referenced by readPersistElements().

bool StarObject::readPersistElements | ( | STOFFInputStreamPtr | input,
|  | std::string const & | name
| ) |  |
| protected

the "persist elements" small ole: the list of object

Referenced by parse().

bool StarObject::readSfxDocumentInformation | ( | STOFFInputStreamPtr | input,
|  | std::string const & | name
| ) |  |
| protected

try to read the document information : "SfxDocumentInformation"

Referenced by parse().

bool StarObject::readSfxPreview | ( | STOFFInputStreamPtr | input,
|  | std::string const & | name
| ) |  |
| protected

try to read the preview : "SfxPreview"

Referenced by parse().

bool StarObject::readSfxStyleSheets | ( | STOFFInputStreamPtr | input,
|  | std::string const & | name
| ) |  |

try to read a spreadshet style zone: SfxStyleSheets

bool StarObject::readSfxWindows | ( | STOFFInputStreamPtr | input,
|  | libstoff::DebugFile & | ascii
| ) |  |
| protected

try to read the windows information : "SfxWindows"

Referenced by parse().

bool StarObject::readStarFrameworkConfigFile | ( | STOFFInputStreamPtr | input,
|  | libstoff::DebugFile & | ascii
| ) |  |
| protected

try to read the "Star Framework Config File"

Referenced by parse().

## Member Data Documentation

shared_ptr<STOFFOLEParser::OleDirectory> StarObject::m_directory
| protected

the directory

Referenced by getDocumentKind(), and parse().

librevenge::RVNGPropertyList StarObject::m_metaData
| protected

the meta data

Referenced by readSfxDocumentInformation().

char const* StarObject::m_password
| protected

the document password

Referenced by parse(), readPersistElements(), and readSfxPreview().

shared_ptr<StarObjectInternal::State> StarObject::m_state
| protected

the state

Referenced by cleanPools(), findItemPool(), getAttributeManager(), getCurrentPool(), getFormatManager(), getNewItemPool(), and StarObject().

The documentation for this class was generated from the following files:

- StarObject.hxx
- StarObject.cxx